﻿using System;
using System.Collections.Generic;
using System.Web;

namespace AppBox
{
    /// <summary>
    /// 模块的权限列表
    /// 在此为每个模块定义可用的权限列表
    /// </summary>
    public enum ModulePowerType
    {
        None,

        // 浏览权限是公共的，每个模块都有
        CanRead,
        //CanDelete,
        //CanEdit,
        //CanAdd,
        
        // 比如这里为核心菜单模块定义了三种权限
        CoreMenu_New,
        CoreMenu_Edit,
        CoreMenu_Delete,


        CoreJobTitle_New,
        CoreJobTitle_Edit,
        CoreJobTitle_Delete,

        CoreJobTitleUser_New,
        CoreJobTitleUser_Delete,


        CoreDept_New,
        CoreDept_Edit,
        CoreDept_Delete,

        CoreDeptUser_New,
        CoreDeptUser_Delete,


        CoreRole_New,
        CoreRole_Edit,
        CoreRole_Delete,

        CoreUser_New,
        CoreUser_Edit,
        CoreUser_Delete,
        CoreUser_ChangePassword,

        CoreRoleUser_New,
        CoreRoleUser_Delete,

        CoreRoleModule_Edit,

        CoreRoleMenu_Edit,

        CoreLog_Delete,

        CoreConf_Edit,

        CorePassword_Edit


    }

    /// <summary>
    /// 模块权限帮助类
    /// </summary>
    public partial class ModulePowerTypeHelper
    {
        /// <summary>
        /// 其他权限的标题
        /// </summary>
        /// <param name="powerName"></param>
        /// <returns></returns>
        public static string GetTitle(string moduleName, string powerName)
        {
            return GetTitle(String2Power(String.Format("{0}_{1}", moduleName, powerName)));
        }

        /// <summary>
        /// 权限的显示标题
        /// </summary>
        /// <param name="power"></param>
        /// <returns></returns>
        public static string GetTitle(ModulePowerType power)
        {
            string result = "未定义！";

            string powerTypeName = ModulePowerTypeHelper.GetPowerTypeName(power);
            if (powerTypeName == "New")
            {
                result = "新增";
            }
            else if (powerTypeName == "Delete")
            {
                result = "删除";
            }
            else if (powerTypeName == "Edit")
            {
                result = "编辑";
            }
            else
            {
                switch (power)
                {
                    case ModulePowerType.CoreUser_ChangePassword:
                        result = "修改密码";
                        break;
                }
            }

            return result;
        }

        

    }

}