using System; 
using System.Text; 
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration; 
using System.Xml; 
using System.Xml.Serialization;
using SubSonic; 
using SubSonic.Utilities;
// <auto-generated />
namespace AppBox
{
	/// <summary>
	/// Strongly-typed collection for the XMenu class.
	/// </summary>
    [Serializable]
	public partial class XMenuCollection : ActiveList<XMenu, XMenuCollection>
	{	   
		public XMenuCollection() {}
        
        /// <summary>
		/// Filters an existing collection based on the set criteria. This is an in-memory filter
		/// Thanks to developingchris for this!
        /// </summary>
        /// <returns>XMenuCollection</returns>
		public XMenuCollection Filter()
        {
            for (int i = this.Count - 1; i > -1; i--)
            {
                XMenu o = this[i];
                foreach (SubSonic.Where w in this.wheres)
                {
                    bool remove = false;
                    System.Reflection.PropertyInfo pi = o.GetType().GetProperty(w.ColumnName);
                    if (pi.CanRead)
                    {
                        object val = pi.GetValue(o, null);
                        switch (w.Comparison)
                        {
                            case SubSonic.Comparison.Equals:
                                if (!val.Equals(w.ParameterValue))
                                {
                                    remove = true;
                                }
                                break;
                        }
                    }
                    if (remove)
                    {
                        this.Remove(o);
                        break;
                    }
                }
            }
            return this;
        }
		
		
	}
	/// <summary>
	/// This is an ActiveRecord class which wraps the X_Menu table.
	/// </summary>
	[Serializable]
	public partial class XMenu : ActiveRecord<XMenu>, IActiveRecord
	{
		#region .ctors and Default Settings
		
		public XMenu()
		{
		  SetSQLProps();
		  InitSetDefaults();
		  MarkNew();
		}
		
		private void InitSetDefaults() { SetDefaults(); }
		
		public XMenu(bool useDatabaseDefaults)
		{
			SetSQLProps();
			if(useDatabaseDefaults)
				ForceDefaults();
			MarkNew();
		}
        
		public XMenu(object keyID)
		{
			SetSQLProps();
			InitSetDefaults();
			LoadByKey(keyID);
		}
		 
		public XMenu(string columnName, object columnValue)
		{
			SetSQLProps();
			InitSetDefaults();
			LoadByParam(columnName,columnValue);
		}
		
		protected static void SetSQLProps() { GetTableSchema(); }
		
		#endregion
		
		#region Schema and Query Accessor	
		public static Query CreateQuery() { return new Query(Schema); }
		public static TableSchema.Table Schema
		{
			get
			{
				if (BaseSchema == null)
					SetSQLProps();
				return BaseSchema;
			}
		}
		
		private static void GetTableSchema() 
		{
			if(!IsSchemaInitialized)
			{
				//Schema declaration
				TableSchema.Table schema = new TableSchema.Table("X_Menu", TableType.Table, DataService.GetInstance("Default"));
				schema.Columns = new TableSchema.TableColumnCollection();
				schema.SchemaName = @"dbo";
				//columns
				
				TableSchema.TableColumn colvarId = new TableSchema.TableColumn(schema);
				colvarId.ColumnName = "Id";
				colvarId.DataType = DbType.Int32;
				colvarId.MaxLength = 0;
				colvarId.AutoIncrement = true;
				colvarId.IsNullable = false;
				colvarId.IsPrimaryKey = true;
				colvarId.IsForeignKey = false;
				colvarId.IsReadOnly = false;
				colvarId.DefaultSetting = @"";
				colvarId.ForeignKeyTableName = "";
				schema.Columns.Add(colvarId);
				
				TableSchema.TableColumn colvarModuleName = new TableSchema.TableColumn(schema);
				colvarModuleName.ColumnName = "ModuleName";
				colvarModuleName.DataType = DbType.String;
				colvarModuleName.MaxLength = 50;
				colvarModuleName.AutoIncrement = false;
				colvarModuleName.IsNullable = false;
				colvarModuleName.IsPrimaryKey = false;
				colvarModuleName.IsForeignKey = false;
				colvarModuleName.IsReadOnly = false;
				colvarModuleName.DefaultSetting = @"";
				colvarModuleName.ForeignKeyTableName = "";
				schema.Columns.Add(colvarModuleName);
				
				TableSchema.TableColumn colvarSyncMenuTitle = new TableSchema.TableColumn(schema);
				colvarSyncMenuTitle.ColumnName = "SyncMenuTitle";
				colvarSyncMenuTitle.DataType = DbType.Boolean;
				colvarSyncMenuTitle.MaxLength = 0;
				colvarSyncMenuTitle.AutoIncrement = false;
				colvarSyncMenuTitle.IsNullable = false;
				colvarSyncMenuTitle.IsPrimaryKey = false;
				colvarSyncMenuTitle.IsForeignKey = false;
				colvarSyncMenuTitle.IsReadOnly = false;
				colvarSyncMenuTitle.DefaultSetting = @"";
				colvarSyncMenuTitle.ForeignKeyTableName = "";
				schema.Columns.Add(colvarSyncMenuTitle);
				
				TableSchema.TableColumn colvarTitle = new TableSchema.TableColumn(schema);
				colvarTitle.ColumnName = "Title";
				colvarTitle.DataType = DbType.String;
				colvarTitle.MaxLength = 50;
				colvarTitle.AutoIncrement = false;
				colvarTitle.IsNullable = false;
				colvarTitle.IsPrimaryKey = false;
				colvarTitle.IsForeignKey = false;
				colvarTitle.IsReadOnly = false;
				colvarTitle.DefaultSetting = @"";
				colvarTitle.ForeignKeyTableName = "";
				schema.Columns.Add(colvarTitle);
				
				TableSchema.TableColumn colvarImageUrl = new TableSchema.TableColumn(schema);
				colvarImageUrl.ColumnName = "ImageUrl";
				colvarImageUrl.DataType = DbType.String;
				colvarImageUrl.MaxLength = 200;
				colvarImageUrl.AutoIncrement = false;
				colvarImageUrl.IsNullable = true;
				colvarImageUrl.IsPrimaryKey = false;
				colvarImageUrl.IsForeignKey = false;
				colvarImageUrl.IsReadOnly = false;
				colvarImageUrl.DefaultSetting = @"";
				colvarImageUrl.ForeignKeyTableName = "";
				schema.Columns.Add(colvarImageUrl);
				
				TableSchema.TableColumn colvarNavigateUrl = new TableSchema.TableColumn(schema);
				colvarNavigateUrl.ColumnName = "NavigateUrl";
				colvarNavigateUrl.DataType = DbType.String;
				colvarNavigateUrl.MaxLength = 200;
				colvarNavigateUrl.AutoIncrement = false;
				colvarNavigateUrl.IsNullable = false;
				colvarNavigateUrl.IsPrimaryKey = false;
				colvarNavigateUrl.IsForeignKey = false;
				colvarNavigateUrl.IsReadOnly = false;
				colvarNavigateUrl.DefaultSetting = @"";
				colvarNavigateUrl.ForeignKeyTableName = "";
				schema.Columns.Add(colvarNavigateUrl);
				
				TableSchema.TableColumn colvarRemark = new TableSchema.TableColumn(schema);
				colvarRemark.ColumnName = "Remark";
				colvarRemark.DataType = DbType.String;
				colvarRemark.MaxLength = 200;
				colvarRemark.AutoIncrement = false;
				colvarRemark.IsNullable = true;
				colvarRemark.IsPrimaryKey = false;
				colvarRemark.IsForeignKey = false;
				colvarRemark.IsReadOnly = false;
				colvarRemark.DefaultSetting = @"";
				colvarRemark.ForeignKeyTableName = "";
				schema.Columns.Add(colvarRemark);
				
				TableSchema.TableColumn colvarParentMenuId = new TableSchema.TableColumn(schema);
				colvarParentMenuId.ColumnName = "ParentMenuId";
				colvarParentMenuId.DataType = DbType.Int32;
				colvarParentMenuId.MaxLength = 0;
				colvarParentMenuId.AutoIncrement = false;
				colvarParentMenuId.IsNullable = false;
				colvarParentMenuId.IsPrimaryKey = false;
				colvarParentMenuId.IsForeignKey = false;
				colvarParentMenuId.IsReadOnly = false;
				colvarParentMenuId.DefaultSetting = @"";
				colvarParentMenuId.ForeignKeyTableName = "";
				schema.Columns.Add(colvarParentMenuId);
				
				TableSchema.TableColumn colvarSortIndex = new TableSchema.TableColumn(schema);
				colvarSortIndex.ColumnName = "SortIndex";
				colvarSortIndex.DataType = DbType.Int32;
				colvarSortIndex.MaxLength = 0;
				colvarSortIndex.AutoIncrement = false;
				colvarSortIndex.IsNullable = false;
				colvarSortIndex.IsPrimaryKey = false;
				colvarSortIndex.IsForeignKey = false;
				colvarSortIndex.IsReadOnly = false;
				colvarSortIndex.DefaultSetting = @"";
				colvarSortIndex.ForeignKeyTableName = "";
				schema.Columns.Add(colvarSortIndex);
				
				BaseSchema = schema;
				//add this schema to the provider
				//so we can query it later
				DataService.Providers["Default"].AddSchema("X_Menu",schema);
			}
		}
		#endregion
		
		#region Props
		  
		[XmlAttribute("Id")]
		[Bindable(true)]
		public int Id 
		{
			get { return GetColumnValue<int>(Columns.Id); }
			set { SetColumnValue(Columns.Id, value); }
		}
		  
		[XmlAttribute("ModuleName")]
		[Bindable(true)]
		public string ModuleName 
		{
			get { return GetColumnValue<string>(Columns.ModuleName); }
			set { SetColumnValue(Columns.ModuleName, value); }
		}
		  
		[XmlAttribute("SyncMenuTitle")]
		[Bindable(true)]
		public bool SyncMenuTitle 
		{
			get { return GetColumnValue<bool>(Columns.SyncMenuTitle); }
			set { SetColumnValue(Columns.SyncMenuTitle, value); }
		}
		  
		[XmlAttribute("Title")]
		[Bindable(true)]
		public string Title 
		{
			get { return GetColumnValue<string>(Columns.Title); }
			set { SetColumnValue(Columns.Title, value); }
		}
		  
		[XmlAttribute("ImageUrl")]
		[Bindable(true)]
		public string ImageUrl 
		{
			get { return GetColumnValue<string>(Columns.ImageUrl); }
			set { SetColumnValue(Columns.ImageUrl, value); }
		}
		  
		[XmlAttribute("NavigateUrl")]
		[Bindable(true)]
		public string NavigateUrl 
		{
			get { return GetColumnValue<string>(Columns.NavigateUrl); }
			set { SetColumnValue(Columns.NavigateUrl, value); }
		}
		  
		[XmlAttribute("Remark")]
		[Bindable(true)]
		public string Remark 
		{
			get { return GetColumnValue<string>(Columns.Remark); }
			set { SetColumnValue(Columns.Remark, value); }
		}
		  
		[XmlAttribute("ParentMenuId")]
		[Bindable(true)]
		public int ParentMenuId 
		{
			get { return GetColumnValue<int>(Columns.ParentMenuId); }
			set { SetColumnValue(Columns.ParentMenuId, value); }
		}
		  
		[XmlAttribute("SortIndex")]
		[Bindable(true)]
		public int SortIndex 
		{
			get { return GetColumnValue<int>(Columns.SortIndex); }
			set { SetColumnValue(Columns.SortIndex, value); }
		}
		
		#endregion
		
		
			
		
		//no foreign key tables defined (0)
		
		
		
		//no ManyToMany tables defined (0)
		
        
        
		#region ObjectDataSource support
		
		
		/// <summary>
		/// Inserts a record, can be used with the Object Data Source
		/// </summary>
		public static void Insert(string varModuleName,bool varSyncMenuTitle,string varTitle,string varImageUrl,string varNavigateUrl,string varRemark,int varParentMenuId,int varSortIndex)
		{
			XMenu item = new XMenu();
			
			item.ModuleName = varModuleName;
			
			item.SyncMenuTitle = varSyncMenuTitle;
			
			item.Title = varTitle;
			
			item.ImageUrl = varImageUrl;
			
			item.NavigateUrl = varNavigateUrl;
			
			item.Remark = varRemark;
			
			item.ParentMenuId = varParentMenuId;
			
			item.SortIndex = varSortIndex;
			
		
			if (System.Web.HttpContext.Current != null)
				item.Save(System.Web.HttpContext.Current.User.Identity.Name);
			else
				item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name);
		}
		
		/// <summary>
		/// Updates a record, can be used with the Object Data Source
		/// </summary>
		public static void Update(int varId,string varModuleName,bool varSyncMenuTitle,string varTitle,string varImageUrl,string varNavigateUrl,string varRemark,int varParentMenuId,int varSortIndex)
		{
			XMenu item = new XMenu();
			
				item.Id = varId;
			
				item.ModuleName = varModuleName;
			
				item.SyncMenuTitle = varSyncMenuTitle;
			
				item.Title = varTitle;
			
				item.ImageUrl = varImageUrl;
			
				item.NavigateUrl = varNavigateUrl;
			
				item.Remark = varRemark;
			
				item.ParentMenuId = varParentMenuId;
			
				item.SortIndex = varSortIndex;
			
			item.IsNew = false;
			if (System.Web.HttpContext.Current != null)
				item.Save(System.Web.HttpContext.Current.User.Identity.Name);
			else
				item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name);
		}
		#endregion
        
        
        
        #region Typed Columns
        
        
        public static TableSchema.TableColumn IdColumn
        {
            get { return Schema.Columns[0]; }
        }
        
        
        
        public static TableSchema.TableColumn ModuleNameColumn
        {
            get { return Schema.Columns[1]; }
        }
        
        
        
        public static TableSchema.TableColumn SyncMenuTitleColumn
        {
            get { return Schema.Columns[2]; }
        }
        
        
        
        public static TableSchema.TableColumn TitleColumn
        {
            get { return Schema.Columns[3]; }
        }
        
        
        
        public static TableSchema.TableColumn ImageUrlColumn
        {
            get { return Schema.Columns[4]; }
        }
        
        
        
        public static TableSchema.TableColumn NavigateUrlColumn
        {
            get { return Schema.Columns[5]; }
        }
        
        
        
        public static TableSchema.TableColumn RemarkColumn
        {
            get { return Schema.Columns[6]; }
        }
        
        
        
        public static TableSchema.TableColumn ParentMenuIdColumn
        {
            get { return Schema.Columns[7]; }
        }
        
        
        
        public static TableSchema.TableColumn SortIndexColumn
        {
            get { return Schema.Columns[8]; }
        }
        
        
        
        #endregion
		#region Columns Struct
		public struct Columns
		{
			 public static string Id = @"Id";
			 public static string ModuleName = @"ModuleName";
			 public static string SyncMenuTitle = @"SyncMenuTitle";
			 public static string Title = @"Title";
			 public static string ImageUrl = @"ImageUrl";
			 public static string NavigateUrl = @"NavigateUrl";
			 public static string Remark = @"Remark";
			 public static string ParentMenuId = @"ParentMenuId";
			 public static string SortIndex = @"SortIndex";
						
		}
		#endregion
		
		#region Update PK Collections
		
        #endregion
    
        #region Deep Save
		
        #endregion
	}
}
