using System; 
using System.Text; 
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration; 
using System.Xml; 
using System.Xml.Serialization;
using SubSonic; 
using SubSonic.Utilities;
// <auto-generated />
namespace AppBox
{
	/// <summary>
	/// Strongly-typed collection for the XRoleModule class.
	/// </summary>
    [Serializable]
	public partial class XRoleModuleCollection : ActiveList<XRoleModule, XRoleModuleCollection>
	{	   
		public XRoleModuleCollection() {}
        
        /// <summary>
		/// Filters an existing collection based on the set criteria. This is an in-memory filter
		/// Thanks to developingchris for this!
        /// </summary>
        /// <returns>XRoleModuleCollection</returns>
		public XRoleModuleCollection Filter()
        {
            for (int i = this.Count - 1; i > -1; i--)
            {
                XRoleModule o = this[i];
                foreach (SubSonic.Where w in this.wheres)
                {
                    bool remove = false;
                    System.Reflection.PropertyInfo pi = o.GetType().GetProperty(w.ColumnName);
                    if (pi.CanRead)
                    {
                        object val = pi.GetValue(o, null);
                        switch (w.Comparison)
                        {
                            case SubSonic.Comparison.Equals:
                                if (!val.Equals(w.ParameterValue))
                                {
                                    remove = true;
                                }
                                break;
                        }
                    }
                    if (remove)
                    {
                        this.Remove(o);
                        break;
                    }
                }
            }
            return this;
        }
		
		
	}
	/// <summary>
	/// This is an ActiveRecord class which wraps the X_RoleModule table.
	/// </summary>
	[Serializable]
	public partial class XRoleModule : ActiveRecord<XRoleModule>, IActiveRecord
	{
		#region .ctors and Default Settings
		
		public XRoleModule()
		{
		  SetSQLProps();
		  InitSetDefaults();
		  MarkNew();
		}
		
		private void InitSetDefaults() { SetDefaults(); }
		
		public XRoleModule(bool useDatabaseDefaults)
		{
			SetSQLProps();
			if(useDatabaseDefaults)
				ForceDefaults();
			MarkNew();
		}
        
		public XRoleModule(object keyID)
		{
			SetSQLProps();
			InitSetDefaults();
			LoadByKey(keyID);
		}
		 
		public XRoleModule(string columnName, object columnValue)
		{
			SetSQLProps();
			InitSetDefaults();
			LoadByParam(columnName,columnValue);
		}
		
		protected static void SetSQLProps() { GetTableSchema(); }
		
		#endregion
		
		#region Schema and Query Accessor	
		public static Query CreateQuery() { return new Query(Schema); }
		public static TableSchema.Table Schema
		{
			get
			{
				if (BaseSchema == null)
					SetSQLProps();
				return BaseSchema;
			}
		}
		
		private static void GetTableSchema() 
		{
			if(!IsSchemaInitialized)
			{
				//Schema declaration
				TableSchema.Table schema = new TableSchema.Table("X_RoleModule", TableType.Table, DataService.GetInstance("Default"));
				schema.Columns = new TableSchema.TableColumnCollection();
				schema.SchemaName = @"dbo";
				//columns
				
				TableSchema.TableColumn colvarId = new TableSchema.TableColumn(schema);
				colvarId.ColumnName = "Id";
				colvarId.DataType = DbType.Int32;
				colvarId.MaxLength = 0;
				colvarId.AutoIncrement = true;
				colvarId.IsNullable = false;
				colvarId.IsPrimaryKey = true;
				colvarId.IsForeignKey = false;
				colvarId.IsReadOnly = false;
				colvarId.DefaultSetting = @"";
				colvarId.ForeignKeyTableName = "";
				schema.Columns.Add(colvarId);
				
				TableSchema.TableColumn colvarRoleId = new TableSchema.TableColumn(schema);
				colvarRoleId.ColumnName = "RoleId";
				colvarRoleId.DataType = DbType.Int32;
				colvarRoleId.MaxLength = 0;
				colvarRoleId.AutoIncrement = false;
				colvarRoleId.IsNullable = false;
				colvarRoleId.IsPrimaryKey = false;
				colvarRoleId.IsForeignKey = false;
				colvarRoleId.IsReadOnly = false;
				colvarRoleId.DefaultSetting = @"";
				colvarRoleId.ForeignKeyTableName = "";
				schema.Columns.Add(colvarRoleId);
				
				TableSchema.TableColumn colvarModuleName = new TableSchema.TableColumn(schema);
				colvarModuleName.ColumnName = "ModuleName";
				colvarModuleName.DataType = DbType.String;
				colvarModuleName.MaxLength = 50;
				colvarModuleName.AutoIncrement = false;
				colvarModuleName.IsNullable = false;
				colvarModuleName.IsPrimaryKey = false;
				colvarModuleName.IsForeignKey = false;
				colvarModuleName.IsReadOnly = false;
				colvarModuleName.DefaultSetting = @"";
				colvarModuleName.ForeignKeyTableName = "";
				schema.Columns.Add(colvarModuleName);
				
				TableSchema.TableColumn colvarCanRead = new TableSchema.TableColumn(schema);
				colvarCanRead.ColumnName = "CanRead";
				colvarCanRead.DataType = DbType.Boolean;
				colvarCanRead.MaxLength = 0;
				colvarCanRead.AutoIncrement = false;
				colvarCanRead.IsNullable = false;
				colvarCanRead.IsPrimaryKey = false;
				colvarCanRead.IsForeignKey = false;
				colvarCanRead.IsReadOnly = false;
				colvarCanRead.DefaultSetting = @"";
				colvarCanRead.ForeignKeyTableName = "";
				schema.Columns.Add(colvarCanRead);
				
				TableSchema.TableColumn colvarOthers = new TableSchema.TableColumn(schema);
				colvarOthers.ColumnName = "Others";
				colvarOthers.DataType = DbType.String;
				colvarOthers.MaxLength = 500;
				colvarOthers.AutoIncrement = false;
				colvarOthers.IsNullable = false;
				colvarOthers.IsPrimaryKey = false;
				colvarOthers.IsForeignKey = false;
				colvarOthers.IsReadOnly = false;
				colvarOthers.DefaultSetting = @"";
				colvarOthers.ForeignKeyTableName = "";
				schema.Columns.Add(colvarOthers);
				
				BaseSchema = schema;
				//add this schema to the provider
				//so we can query it later
				DataService.Providers["Default"].AddSchema("X_RoleModule",schema);
			}
		}
		#endregion
		
		#region Props
		  
		[XmlAttribute("Id")]
		[Bindable(true)]
		public int Id 
		{
			get { return GetColumnValue<int>(Columns.Id); }
			set { SetColumnValue(Columns.Id, value); }
		}
		  
		[XmlAttribute("RoleId")]
		[Bindable(true)]
		public int RoleId 
		{
			get { return GetColumnValue<int>(Columns.RoleId); }
			set { SetColumnValue(Columns.RoleId, value); }
		}
		  
		[XmlAttribute("ModuleName")]
		[Bindable(true)]
		public string ModuleName 
		{
			get { return GetColumnValue<string>(Columns.ModuleName); }
			set { SetColumnValue(Columns.ModuleName, value); }
		}
		  
		[XmlAttribute("CanRead")]
		[Bindable(true)]
		public bool CanRead 
		{
			get { return GetColumnValue<bool>(Columns.CanRead); }
			set { SetColumnValue(Columns.CanRead, value); }
		}
		  
		[XmlAttribute("Others")]
		[Bindable(true)]
		public string Others 
		{
			get { return GetColumnValue<string>(Columns.Others); }
			set { SetColumnValue(Columns.Others, value); }
		}
		
		#endregion
		
		
			
		
		//no foreign key tables defined (0)
		
		
		
		//no ManyToMany tables defined (0)
		
        
        
		#region ObjectDataSource support
		
		
		/// <summary>
		/// Inserts a record, can be used with the Object Data Source
		/// </summary>
		public static void Insert(int varRoleId,string varModuleName,bool varCanRead,string varOthers)
		{
			XRoleModule item = new XRoleModule();
			
			item.RoleId = varRoleId;
			
			item.ModuleName = varModuleName;
			
			item.CanRead = varCanRead;
			
			item.Others = varOthers;
			
		
			if (System.Web.HttpContext.Current != null)
				item.Save(System.Web.HttpContext.Current.User.Identity.Name);
			else
				item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name);
		}
		
		/// <summary>
		/// Updates a record, can be used with the Object Data Source
		/// </summary>
		public static void Update(int varId,int varRoleId,string varModuleName,bool varCanRead,string varOthers)
		{
			XRoleModule item = new XRoleModule();
			
				item.Id = varId;
			
				item.RoleId = varRoleId;
			
				item.ModuleName = varModuleName;
			
				item.CanRead = varCanRead;
			
				item.Others = varOthers;
			
			item.IsNew = false;
			if (System.Web.HttpContext.Current != null)
				item.Save(System.Web.HttpContext.Current.User.Identity.Name);
			else
				item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name);
		}
		#endregion
        
        
        
        #region Typed Columns
        
        
        public static TableSchema.TableColumn IdColumn
        {
            get { return Schema.Columns[0]; }
        }
        
        
        
        public static TableSchema.TableColumn RoleIdColumn
        {
            get { return Schema.Columns[1]; }
        }
        
        
        
        public static TableSchema.TableColumn ModuleNameColumn
        {
            get { return Schema.Columns[2]; }
        }
        
        
        
        public static TableSchema.TableColumn CanReadColumn
        {
            get { return Schema.Columns[3]; }
        }
        
        
        
        public static TableSchema.TableColumn OthersColumn
        {
            get { return Schema.Columns[4]; }
        }
        
        
        
        #endregion
		#region Columns Struct
		public struct Columns
		{
			 public static string Id = @"Id";
			 public static string RoleId = @"RoleId";
			 public static string ModuleName = @"ModuleName";
			 public static string CanRead = @"CanRead";
			 public static string Others = @"Others";
						
		}
		#endregion
		
		#region Update PK Collections
		
        #endregion
    
        #region Deep Save
		
        #endregion
	}
}
