using System; 
using System.Text; 
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration; 
using System.Xml; 
using System.Xml.Serialization;
using SubSonic; 
using SubSonic.Utilities;
// <auto-generated />
namespace AppBox
{
    /// <summary>
    /// Controller class for X_RoleModule
    /// </summary>
    [System.ComponentModel.DataObject]
    public partial class XRoleModuleController
    {
        // Preload our schema..
        XRoleModule thisSchemaLoad = new XRoleModule();
        private string userName = String.Empty;
        protected string UserName
        {
            get
            {
				if (userName.Length == 0) 
				{
    				if (System.Web.HttpContext.Current != null)
    				{
						userName=System.Web.HttpContext.Current.User.Identity.Name;
					}
					else
					{
						userName=System.Threading.Thread.CurrentPrincipal.Identity.Name;
					}
				}
				return userName;
            }
        }
        [DataObjectMethod(DataObjectMethodType.Select, true)]
        public XRoleModuleCollection FetchAll()
        {
            XRoleModuleCollection coll = new XRoleModuleCollection();
            Query qry = new Query(XRoleModule.Schema);
            coll.LoadAndCloseReader(qry.ExecuteReader());
            return coll;
        }
        [DataObjectMethod(DataObjectMethodType.Select, false)]
        public XRoleModuleCollection FetchByID(object Id)
        {
            XRoleModuleCollection coll = new XRoleModuleCollection().Where("Id", Id).Load();
            return coll;
        }
		
		[DataObjectMethod(DataObjectMethodType.Select, false)]
        public XRoleModuleCollection FetchByQuery(Query qry)
        {
            XRoleModuleCollection coll = new XRoleModuleCollection();
            coll.LoadAndCloseReader(qry.ExecuteReader()); 
            return coll;
        }
        [DataObjectMethod(DataObjectMethodType.Delete, true)]
        public bool Delete(object Id)
        {
            return (XRoleModule.Delete(Id) == 1);
        }
        [DataObjectMethod(DataObjectMethodType.Delete, false)]
        public bool Destroy(object Id)
        {
            return (XRoleModule.Destroy(Id) == 1);
        }
        
        
    	
	    /// <summary>
	    /// Inserts a record, can be used with the Object Data Source
	    /// </summary>
        [DataObjectMethod(DataObjectMethodType.Insert, true)]
	    public void Insert(int RoleId,string ModuleName,bool CanRead,string Others)
	    {
		    XRoleModule item = new XRoleModule();
		    
            item.RoleId = RoleId;
            
            item.ModuleName = ModuleName;
            
            item.CanRead = CanRead;
            
            item.Others = Others;
            
	    
		    item.Save(UserName);
	    }
    	
	    /// <summary>
	    /// Updates a record, can be used with the Object Data Source
	    /// </summary>
        [DataObjectMethod(DataObjectMethodType.Update, true)]
	    public void Update(int Id,int RoleId,string ModuleName,bool CanRead,string Others)
	    {
		    XRoleModule item = new XRoleModule();
	        item.MarkOld();
	        item.IsLoaded = true;
		    
			item.Id = Id;
				
			item.RoleId = RoleId;
				
			item.ModuleName = ModuleName;
				
			item.CanRead = CanRead;
				
			item.Others = Others;
				
	        item.Save(UserName);
	    }
    }
}
