using System; 
using System.Text; 
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration; 
using System.Xml; 
using System.Xml.Serialization;
using SubSonic; 
using SubSonic.Utilities;
// <auto-generated />
namespace AppBox
{
	/// <summary>
	/// Strongly-typed collection for the XUser class.
	/// </summary>
    [Serializable]
	public partial class XUserCollection : ActiveList<XUser, XUserCollection>
	{	   
		public XUserCollection() {}
        
        /// <summary>
		/// Filters an existing collection based on the set criteria. This is an in-memory filter
		/// Thanks to developingchris for this!
        /// </summary>
        /// <returns>XUserCollection</returns>
		public XUserCollection Filter()
        {
            for (int i = this.Count - 1; i > -1; i--)
            {
                XUser o = this[i];
                foreach (SubSonic.Where w in this.wheres)
                {
                    bool remove = false;
                    System.Reflection.PropertyInfo pi = o.GetType().GetProperty(w.ColumnName);
                    if (pi.CanRead)
                    {
                        object val = pi.GetValue(o, null);
                        switch (w.Comparison)
                        {
                            case SubSonic.Comparison.Equals:
                                if (!val.Equals(w.ParameterValue))
                                {
                                    remove = true;
                                }
                                break;
                        }
                    }
                    if (remove)
                    {
                        this.Remove(o);
                        break;
                    }
                }
            }
            return this;
        }
		
		
	}
	/// <summary>
	/// This is an ActiveRecord class which wraps the X_User table.
	/// </summary>
	[Serializable]
	public partial class XUser : ActiveRecord<XUser>, IActiveRecord
	{
		#region .ctors and Default Settings
		
		public XUser()
		{
		  SetSQLProps();
		  InitSetDefaults();
		  MarkNew();
		}
		
		private void InitSetDefaults() { SetDefaults(); }
		
		public XUser(bool useDatabaseDefaults)
		{
			SetSQLProps();
			if(useDatabaseDefaults)
				ForceDefaults();
			MarkNew();
		}
        
		public XUser(object keyID)
		{
			SetSQLProps();
			InitSetDefaults();
			LoadByKey(keyID);
		}
		 
		public XUser(string columnName, object columnValue)
		{
			SetSQLProps();
			InitSetDefaults();
			LoadByParam(columnName,columnValue);
		}
		
		protected static void SetSQLProps() { GetTableSchema(); }
		
		#endregion
		
		#region Schema and Query Accessor	
		public static Query CreateQuery() { return new Query(Schema); }
		public static TableSchema.Table Schema
		{
			get
			{
				if (BaseSchema == null)
					SetSQLProps();
				return BaseSchema;
			}
		}
		
		private static void GetTableSchema() 
		{
			if(!IsSchemaInitialized)
			{
				//Schema declaration
				TableSchema.Table schema = new TableSchema.Table("X_User", TableType.Table, DataService.GetInstance("Default"));
				schema.Columns = new TableSchema.TableColumnCollection();
				schema.SchemaName = @"dbo";
				//columns
				
				TableSchema.TableColumn colvarId = new TableSchema.TableColumn(schema);
				colvarId.ColumnName = "Id";
				colvarId.DataType = DbType.Int32;
				colvarId.MaxLength = 0;
				colvarId.AutoIncrement = true;
				colvarId.IsNullable = false;
				colvarId.IsPrimaryKey = true;
				colvarId.IsForeignKey = false;
				colvarId.IsReadOnly = false;
				colvarId.DefaultSetting = @"";
				colvarId.ForeignKeyTableName = "";
				schema.Columns.Add(colvarId);
				
				TableSchema.TableColumn colvarName = new TableSchema.TableColumn(schema);
				colvarName.ColumnName = "Name";
				colvarName.DataType = DbType.String;
				colvarName.MaxLength = 50;
				colvarName.AutoIncrement = false;
				colvarName.IsNullable = false;
				colvarName.IsPrimaryKey = false;
				colvarName.IsForeignKey = false;
				colvarName.IsReadOnly = false;
				colvarName.DefaultSetting = @"";
				colvarName.ForeignKeyTableName = "";
				schema.Columns.Add(colvarName);
				
				TableSchema.TableColumn colvarPassword = new TableSchema.TableColumn(schema);
				colvarPassword.ColumnName = "Password";
				colvarPassword.DataType = DbType.String;
				colvarPassword.MaxLength = 50;
				colvarPassword.AutoIncrement = false;
				colvarPassword.IsNullable = false;
				colvarPassword.IsPrimaryKey = false;
				colvarPassword.IsForeignKey = false;
				colvarPassword.IsReadOnly = false;
				colvarPassword.DefaultSetting = @"";
				colvarPassword.ForeignKeyTableName = "";
				schema.Columns.Add(colvarPassword);
				
				TableSchema.TableColumn colvarEnabled = new TableSchema.TableColumn(schema);
				colvarEnabled.ColumnName = "Enabled";
				colvarEnabled.DataType = DbType.Boolean;
				colvarEnabled.MaxLength = 0;
				colvarEnabled.AutoIncrement = false;
				colvarEnabled.IsNullable = false;
				colvarEnabled.IsPrimaryKey = false;
				colvarEnabled.IsForeignKey = false;
				colvarEnabled.IsReadOnly = false;
				colvarEnabled.DefaultSetting = @"";
				colvarEnabled.ForeignKeyTableName = "";
				schema.Columns.Add(colvarEnabled);
				
				TableSchema.TableColumn colvarGender = new TableSchema.TableColumn(schema);
				colvarGender.ColumnName = "Gender";
				colvarGender.DataType = DbType.String;
				colvarGender.MaxLength = 10;
				colvarGender.AutoIncrement = false;
				colvarGender.IsNullable = true;
				colvarGender.IsPrimaryKey = false;
				colvarGender.IsForeignKey = false;
				colvarGender.IsReadOnly = false;
				colvarGender.DefaultSetting = @"";
				colvarGender.ForeignKeyTableName = "";
				schema.Columns.Add(colvarGender);
				
				TableSchema.TableColumn colvarPhoto = new TableSchema.TableColumn(schema);
				colvarPhoto.ColumnName = "Photo";
				colvarPhoto.DataType = DbType.String;
				colvarPhoto.MaxLength = 200;
				colvarPhoto.AutoIncrement = false;
				colvarPhoto.IsNullable = true;
				colvarPhoto.IsPrimaryKey = false;
				colvarPhoto.IsForeignKey = false;
				colvarPhoto.IsReadOnly = false;
				colvarPhoto.DefaultSetting = @"";
				colvarPhoto.ForeignKeyTableName = "";
				schema.Columns.Add(colvarPhoto);
				
				TableSchema.TableColumn colvarEnglishName = new TableSchema.TableColumn(schema);
				colvarEnglishName.ColumnName = "EnglishName";
				colvarEnglishName.DataType = DbType.String;
				colvarEnglishName.MaxLength = 100;
				colvarEnglishName.AutoIncrement = false;
				colvarEnglishName.IsNullable = true;
				colvarEnglishName.IsPrimaryKey = false;
				colvarEnglishName.IsForeignKey = false;
				colvarEnglishName.IsReadOnly = false;
				colvarEnglishName.DefaultSetting = @"";
				colvarEnglishName.ForeignKeyTableName = "";
				schema.Columns.Add(colvarEnglishName);
				
				TableSchema.TableColumn colvarChineseName = new TableSchema.TableColumn(schema);
				colvarChineseName.ColumnName = "ChineseName";
				colvarChineseName.DataType = DbType.String;
				colvarChineseName.MaxLength = 100;
				colvarChineseName.AutoIncrement = false;
				colvarChineseName.IsNullable = true;
				colvarChineseName.IsPrimaryKey = false;
				colvarChineseName.IsForeignKey = false;
				colvarChineseName.IsReadOnly = false;
				colvarChineseName.DefaultSetting = @"";
				colvarChineseName.ForeignKeyTableName = "";
				schema.Columns.Add(colvarChineseName);
				
				TableSchema.TableColumn colvarQq = new TableSchema.TableColumn(schema);
				colvarQq.ColumnName = "QQ";
				colvarQq.DataType = DbType.String;
				colvarQq.MaxLength = 50;
				colvarQq.AutoIncrement = false;
				colvarQq.IsNullable = true;
				colvarQq.IsPrimaryKey = false;
				colvarQq.IsForeignKey = false;
				colvarQq.IsReadOnly = false;
				colvarQq.DefaultSetting = @"";
				colvarQq.ForeignKeyTableName = "";
				schema.Columns.Add(colvarQq);
				
				TableSchema.TableColumn colvarCompanyEmail = new TableSchema.TableColumn(schema);
				colvarCompanyEmail.ColumnName = "CompanyEmail";
				colvarCompanyEmail.DataType = DbType.String;
				colvarCompanyEmail.MaxLength = 100;
				colvarCompanyEmail.AutoIncrement = false;
				colvarCompanyEmail.IsNullable = true;
				colvarCompanyEmail.IsPrimaryKey = false;
				colvarCompanyEmail.IsForeignKey = false;
				colvarCompanyEmail.IsReadOnly = false;
				colvarCompanyEmail.DefaultSetting = @"";
				colvarCompanyEmail.ForeignKeyTableName = "";
				schema.Columns.Add(colvarCompanyEmail);
				
				TableSchema.TableColumn colvarPersonalEmail = new TableSchema.TableColumn(schema);
				colvarPersonalEmail.ColumnName = "PersonalEmail";
				colvarPersonalEmail.DataType = DbType.String;
				colvarPersonalEmail.MaxLength = 100;
				colvarPersonalEmail.AutoIncrement = false;
				colvarPersonalEmail.IsNullable = true;
				colvarPersonalEmail.IsPrimaryKey = false;
				colvarPersonalEmail.IsForeignKey = false;
				colvarPersonalEmail.IsReadOnly = false;
				colvarPersonalEmail.DefaultSetting = @"";
				colvarPersonalEmail.ForeignKeyTableName = "";
				schema.Columns.Add(colvarPersonalEmail);
				
				TableSchema.TableColumn colvarOfficePhone = new TableSchema.TableColumn(schema);
				colvarOfficePhone.ColumnName = "OfficePhone";
				colvarOfficePhone.DataType = DbType.String;
				colvarOfficePhone.MaxLength = 50;
				colvarOfficePhone.AutoIncrement = false;
				colvarOfficePhone.IsNullable = true;
				colvarOfficePhone.IsPrimaryKey = false;
				colvarOfficePhone.IsForeignKey = false;
				colvarOfficePhone.IsReadOnly = false;
				colvarOfficePhone.DefaultSetting = @"";
				colvarOfficePhone.ForeignKeyTableName = "";
				schema.Columns.Add(colvarOfficePhone);
				
				TableSchema.TableColumn colvarOfficePhoneExt = new TableSchema.TableColumn(schema);
				colvarOfficePhoneExt.ColumnName = "OfficePhoneExt";
				colvarOfficePhoneExt.DataType = DbType.String;
				colvarOfficePhoneExt.MaxLength = 50;
				colvarOfficePhoneExt.AutoIncrement = false;
				colvarOfficePhoneExt.IsNullable = true;
				colvarOfficePhoneExt.IsPrimaryKey = false;
				colvarOfficePhoneExt.IsForeignKey = false;
				colvarOfficePhoneExt.IsReadOnly = false;
				colvarOfficePhoneExt.DefaultSetting = @"";
				colvarOfficePhoneExt.ForeignKeyTableName = "";
				schema.Columns.Add(colvarOfficePhoneExt);
				
				TableSchema.TableColumn colvarHomePhone = new TableSchema.TableColumn(schema);
				colvarHomePhone.ColumnName = "HomePhone";
				colvarHomePhone.DataType = DbType.String;
				colvarHomePhone.MaxLength = 50;
				colvarHomePhone.AutoIncrement = false;
				colvarHomePhone.IsNullable = true;
				colvarHomePhone.IsPrimaryKey = false;
				colvarHomePhone.IsForeignKey = false;
				colvarHomePhone.IsReadOnly = false;
				colvarHomePhone.DefaultSetting = @"";
				colvarHomePhone.ForeignKeyTableName = "";
				schema.Columns.Add(colvarHomePhone);
				
				TableSchema.TableColumn colvarCellPhone = new TableSchema.TableColumn(schema);
				colvarCellPhone.ColumnName = "CellPhone";
				colvarCellPhone.DataType = DbType.String;
				colvarCellPhone.MaxLength = 50;
				colvarCellPhone.AutoIncrement = false;
				colvarCellPhone.IsNullable = true;
				colvarCellPhone.IsPrimaryKey = false;
				colvarCellPhone.IsForeignKey = false;
				colvarCellPhone.IsReadOnly = false;
				colvarCellPhone.DefaultSetting = @"";
				colvarCellPhone.ForeignKeyTableName = "";
				schema.Columns.Add(colvarCellPhone);
				
				TableSchema.TableColumn colvarAddress = new TableSchema.TableColumn(schema);
				colvarAddress.ColumnName = "Address";
				colvarAddress.DataType = DbType.String;
				colvarAddress.MaxLength = 500;
				colvarAddress.AutoIncrement = false;
				colvarAddress.IsNullable = true;
				colvarAddress.IsPrimaryKey = false;
				colvarAddress.IsForeignKey = false;
				colvarAddress.IsReadOnly = false;
				colvarAddress.DefaultSetting = @"";
				colvarAddress.ForeignKeyTableName = "";
				schema.Columns.Add(colvarAddress);
				
				TableSchema.TableColumn colvarRemark = new TableSchema.TableColumn(schema);
				colvarRemark.ColumnName = "Remark";
				colvarRemark.DataType = DbType.String;
				colvarRemark.MaxLength = 500;
				colvarRemark.AutoIncrement = false;
				colvarRemark.IsNullable = true;
				colvarRemark.IsPrimaryKey = false;
				colvarRemark.IsForeignKey = false;
				colvarRemark.IsReadOnly = false;
				colvarRemark.DefaultSetting = @"";
				colvarRemark.ForeignKeyTableName = "";
				schema.Columns.Add(colvarRemark);
				
				TableSchema.TableColumn colvarBirthday = new TableSchema.TableColumn(schema);
				colvarBirthday.ColumnName = "Birthday";
				colvarBirthday.DataType = DbType.AnsiString;
				colvarBirthday.MaxLength = 0;
				colvarBirthday.AutoIncrement = false;
				colvarBirthday.IsNullable = true;
				colvarBirthday.IsPrimaryKey = false;
				colvarBirthday.IsForeignKey = false;
				colvarBirthday.IsReadOnly = false;
				colvarBirthday.DefaultSetting = @"";
				colvarBirthday.ForeignKeyTableName = "";
				schema.Columns.Add(colvarBirthday);
				
				TableSchema.TableColumn colvarIdentityCard = new TableSchema.TableColumn(schema);
				colvarIdentityCard.ColumnName = "IdentityCard";
				colvarIdentityCard.DataType = DbType.String;
				colvarIdentityCard.MaxLength = 50;
				colvarIdentityCard.AutoIncrement = false;
				colvarIdentityCard.IsNullable = true;
				colvarIdentityCard.IsPrimaryKey = false;
				colvarIdentityCard.IsForeignKey = false;
				colvarIdentityCard.IsReadOnly = false;
				colvarIdentityCard.DefaultSetting = @"";
				colvarIdentityCard.ForeignKeyTableName = "";
				schema.Columns.Add(colvarIdentityCard);
				
				TableSchema.TableColumn colvarTakeOfficeTime = new TableSchema.TableColumn(schema);
				colvarTakeOfficeTime.ColumnName = "TakeOfficeTime";
				colvarTakeOfficeTime.DataType = DbType.DateTime;
				colvarTakeOfficeTime.MaxLength = 0;
				colvarTakeOfficeTime.AutoIncrement = false;
				colvarTakeOfficeTime.IsNullable = true;
				colvarTakeOfficeTime.IsPrimaryKey = false;
				colvarTakeOfficeTime.IsForeignKey = false;
				colvarTakeOfficeTime.IsReadOnly = false;
				colvarTakeOfficeTime.DefaultSetting = @"";
				colvarTakeOfficeTime.ForeignKeyTableName = "";
				schema.Columns.Add(colvarTakeOfficeTime);
				
				TableSchema.TableColumn colvarLastLoginTime = new TableSchema.TableColumn(schema);
				colvarLastLoginTime.ColumnName = "LastLoginTime";
				colvarLastLoginTime.DataType = DbType.DateTime;
				colvarLastLoginTime.MaxLength = 0;
				colvarLastLoginTime.AutoIncrement = false;
				colvarLastLoginTime.IsNullable = true;
				colvarLastLoginTime.IsPrimaryKey = false;
				colvarLastLoginTime.IsForeignKey = false;
				colvarLastLoginTime.IsReadOnly = false;
				colvarLastLoginTime.DefaultSetting = @"";
				colvarLastLoginTime.ForeignKeyTableName = "";
				schema.Columns.Add(colvarLastLoginTime);
				
				TableSchema.TableColumn colvarCreateTime = new TableSchema.TableColumn(schema);
				colvarCreateTime.ColumnName = "CreateTime";
				colvarCreateTime.DataType = DbType.DateTime;
				colvarCreateTime.MaxLength = 0;
				colvarCreateTime.AutoIncrement = false;
				colvarCreateTime.IsNullable = true;
				colvarCreateTime.IsPrimaryKey = false;
				colvarCreateTime.IsForeignKey = false;
				colvarCreateTime.IsReadOnly = false;
				colvarCreateTime.DefaultSetting = @"";
				colvarCreateTime.ForeignKeyTableName = "";
				schema.Columns.Add(colvarCreateTime);
				
				BaseSchema = schema;
				//add this schema to the provider
				//so we can query it later
				DataService.Providers["Default"].AddSchema("X_User",schema);
			}
		}
		#endregion
		
		#region Props
		  
		[XmlAttribute("Id")]
		[Bindable(true)]
		public int Id 
		{
			get { return GetColumnValue<int>(Columns.Id); }
			set { SetColumnValue(Columns.Id, value); }
		}
		  
		[XmlAttribute("Name")]
		[Bindable(true)]
		public string Name 
		{
			get { return GetColumnValue<string>(Columns.Name); }
			set { SetColumnValue(Columns.Name, value); }
		}
		  
		[XmlAttribute("Password")]
		[Bindable(true)]
		public string Password 
		{
			get { return GetColumnValue<string>(Columns.Password); }
			set { SetColumnValue(Columns.Password, value); }
		}
		  
		[XmlAttribute("Enabled")]
		[Bindable(true)]
		public bool Enabled 
		{
			get { return GetColumnValue<bool>(Columns.Enabled); }
			set { SetColumnValue(Columns.Enabled, value); }
		}
		  
		[XmlAttribute("Gender")]
		[Bindable(true)]
		public string Gender 
		{
			get { return GetColumnValue<string>(Columns.Gender); }
			set { SetColumnValue(Columns.Gender, value); }
		}
		  
		[XmlAttribute("Photo")]
		[Bindable(true)]
		public string Photo 
		{
			get { return GetColumnValue<string>(Columns.Photo); }
			set { SetColumnValue(Columns.Photo, value); }
		}
		  
		[XmlAttribute("EnglishName")]
		[Bindable(true)]
		public string EnglishName 
		{
			get { return GetColumnValue<string>(Columns.EnglishName); }
			set { SetColumnValue(Columns.EnglishName, value); }
		}
		  
		[XmlAttribute("ChineseName")]
		[Bindable(true)]
		public string ChineseName 
		{
			get { return GetColumnValue<string>(Columns.ChineseName); }
			set { SetColumnValue(Columns.ChineseName, value); }
		}
		  
		[XmlAttribute("Qq")]
		[Bindable(true)]
		public string Qq 
		{
			get { return GetColumnValue<string>(Columns.Qq); }
			set { SetColumnValue(Columns.Qq, value); }
		}
		  
		[XmlAttribute("CompanyEmail")]
		[Bindable(true)]
		public string CompanyEmail 
		{
			get { return GetColumnValue<string>(Columns.CompanyEmail); }
			set { SetColumnValue(Columns.CompanyEmail, value); }
		}
		  
		[XmlAttribute("PersonalEmail")]
		[Bindable(true)]
		public string PersonalEmail 
		{
			get { return GetColumnValue<string>(Columns.PersonalEmail); }
			set { SetColumnValue(Columns.PersonalEmail, value); }
		}
		  
		[XmlAttribute("OfficePhone")]
		[Bindable(true)]
		public string OfficePhone 
		{
			get { return GetColumnValue<string>(Columns.OfficePhone); }
			set { SetColumnValue(Columns.OfficePhone, value); }
		}
		  
		[XmlAttribute("OfficePhoneExt")]
		[Bindable(true)]
		public string OfficePhoneExt 
		{
			get { return GetColumnValue<string>(Columns.OfficePhoneExt); }
			set { SetColumnValue(Columns.OfficePhoneExt, value); }
		}
		  
		[XmlAttribute("HomePhone")]
		[Bindable(true)]
		public string HomePhone 
		{
			get { return GetColumnValue<string>(Columns.HomePhone); }
			set { SetColumnValue(Columns.HomePhone, value); }
		}
		  
		[XmlAttribute("CellPhone")]
		[Bindable(true)]
		public string CellPhone 
		{
			get { return GetColumnValue<string>(Columns.CellPhone); }
			set { SetColumnValue(Columns.CellPhone, value); }
		}
		  
		[XmlAttribute("Address")]
		[Bindable(true)]
		public string Address 
		{
			get { return GetColumnValue<string>(Columns.Address); }
			set { SetColumnValue(Columns.Address, value); }
		}
		  
		[XmlAttribute("Remark")]
		[Bindable(true)]
		public string Remark 
		{
			get { return GetColumnValue<string>(Columns.Remark); }
			set { SetColumnValue(Columns.Remark, value); }
		}
		  
		[XmlAttribute("Birthday")]
		[Bindable(true)]
		public string Birthday 
		{
			get { return GetColumnValue<string>(Columns.Birthday); }
			set { SetColumnValue(Columns.Birthday, value); }
		}
		  
		[XmlAttribute("IdentityCard")]
		[Bindable(true)]
		public string IdentityCard 
		{
			get { return GetColumnValue<string>(Columns.IdentityCard); }
			set { SetColumnValue(Columns.IdentityCard, value); }
		}
		  
		[XmlAttribute("TakeOfficeTime")]
		[Bindable(true)]
		public DateTime? TakeOfficeTime 
		{
			get { return GetColumnValue<DateTime?>(Columns.TakeOfficeTime); }
			set { SetColumnValue(Columns.TakeOfficeTime, value); }
		}
		  
		[XmlAttribute("LastLoginTime")]
		[Bindable(true)]
		public DateTime? LastLoginTime 
		{
			get { return GetColumnValue<DateTime?>(Columns.LastLoginTime); }
			set { SetColumnValue(Columns.LastLoginTime, value); }
		}
		  
		[XmlAttribute("CreateTime")]
		[Bindable(true)]
		public DateTime? CreateTime 
		{
			get { return GetColumnValue<DateTime?>(Columns.CreateTime); }
			set { SetColumnValue(Columns.CreateTime, value); }
		}
		
		#endregion
		
		
			
		
		//no foreign key tables defined (0)
		
		
		
		//no ManyToMany tables defined (0)
		
        
        
		#region ObjectDataSource support
		
		
		/// <summary>
		/// Inserts a record, can be used with the Object Data Source
		/// </summary>
		public static void Insert(string varName,string varPassword,bool varEnabled,string varGender,string varPhoto,string varEnglishName,string varChineseName,string varQq,string varCompanyEmail,string varPersonalEmail,string varOfficePhone,string varOfficePhoneExt,string varHomePhone,string varCellPhone,string varAddress,string varRemark,string varBirthday,string varIdentityCard,DateTime? varTakeOfficeTime,DateTime? varLastLoginTime,DateTime? varCreateTime)
		{
			XUser item = new XUser();
			
			item.Name = varName;
			
			item.Password = varPassword;
			
			item.Enabled = varEnabled;
			
			item.Gender = varGender;
			
			item.Photo = varPhoto;
			
			item.EnglishName = varEnglishName;
			
			item.ChineseName = varChineseName;
			
			item.Qq = varQq;
			
			item.CompanyEmail = varCompanyEmail;
			
			item.PersonalEmail = varPersonalEmail;
			
			item.OfficePhone = varOfficePhone;
			
			item.OfficePhoneExt = varOfficePhoneExt;
			
			item.HomePhone = varHomePhone;
			
			item.CellPhone = varCellPhone;
			
			item.Address = varAddress;
			
			item.Remark = varRemark;
			
			item.Birthday = varBirthday;
			
			item.IdentityCard = varIdentityCard;
			
			item.TakeOfficeTime = varTakeOfficeTime;
			
			item.LastLoginTime = varLastLoginTime;
			
			item.CreateTime = varCreateTime;
			
		
			if (System.Web.HttpContext.Current != null)
				item.Save(System.Web.HttpContext.Current.User.Identity.Name);
			else
				item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name);
		}
		
		/// <summary>
		/// Updates a record, can be used with the Object Data Source
		/// </summary>
		public static void Update(int varId,string varName,string varPassword,bool varEnabled,string varGender,string varPhoto,string varEnglishName,string varChineseName,string varQq,string varCompanyEmail,string varPersonalEmail,string varOfficePhone,string varOfficePhoneExt,string varHomePhone,string varCellPhone,string varAddress,string varRemark,string varBirthday,string varIdentityCard,DateTime? varTakeOfficeTime,DateTime? varLastLoginTime,DateTime? varCreateTime)
		{
			XUser item = new XUser();
			
				item.Id = varId;
			
				item.Name = varName;
			
				item.Password = varPassword;
			
				item.Enabled = varEnabled;
			
				item.Gender = varGender;
			
				item.Photo = varPhoto;
			
				item.EnglishName = varEnglishName;
			
				item.ChineseName = varChineseName;
			
				item.Qq = varQq;
			
				item.CompanyEmail = varCompanyEmail;
			
				item.PersonalEmail = varPersonalEmail;
			
				item.OfficePhone = varOfficePhone;
			
				item.OfficePhoneExt = varOfficePhoneExt;
			
				item.HomePhone = varHomePhone;
			
				item.CellPhone = varCellPhone;
			
				item.Address = varAddress;
			
				item.Remark = varRemark;
			
				item.Birthday = varBirthday;
			
				item.IdentityCard = varIdentityCard;
			
				item.TakeOfficeTime = varTakeOfficeTime;
			
				item.LastLoginTime = varLastLoginTime;
			
				item.CreateTime = varCreateTime;
			
			item.IsNew = false;
			if (System.Web.HttpContext.Current != null)
				item.Save(System.Web.HttpContext.Current.User.Identity.Name);
			else
				item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name);
		}
		#endregion
        
        
        
        #region Typed Columns
        
        
        public static TableSchema.TableColumn IdColumn
        {
            get { return Schema.Columns[0]; }
        }
        
        
        
        public static TableSchema.TableColumn NameColumn
        {
            get { return Schema.Columns[1]; }
        }
        
        
        
        public static TableSchema.TableColumn PasswordColumn
        {
            get { return Schema.Columns[2]; }
        }
        
        
        
        public static TableSchema.TableColumn EnabledColumn
        {
            get { return Schema.Columns[3]; }
        }
        
        
        
        public static TableSchema.TableColumn GenderColumn
        {
            get { return Schema.Columns[4]; }
        }
        
        
        
        public static TableSchema.TableColumn PhotoColumn
        {
            get { return Schema.Columns[5]; }
        }
        
        
        
        public static TableSchema.TableColumn EnglishNameColumn
        {
            get { return Schema.Columns[6]; }
        }
        
        
        
        public static TableSchema.TableColumn ChineseNameColumn
        {
            get { return Schema.Columns[7]; }
        }
        
        
        
        public static TableSchema.TableColumn QqColumn
        {
            get { return Schema.Columns[8]; }
        }
        
        
        
        public static TableSchema.TableColumn CompanyEmailColumn
        {
            get { return Schema.Columns[9]; }
        }
        
        
        
        public static TableSchema.TableColumn PersonalEmailColumn
        {
            get { return Schema.Columns[10]; }
        }
        
        
        
        public static TableSchema.TableColumn OfficePhoneColumn
        {
            get { return Schema.Columns[11]; }
        }
        
        
        
        public static TableSchema.TableColumn OfficePhoneExtColumn
        {
            get { return Schema.Columns[12]; }
        }
        
        
        
        public static TableSchema.TableColumn HomePhoneColumn
        {
            get { return Schema.Columns[13]; }
        }
        
        
        
        public static TableSchema.TableColumn CellPhoneColumn
        {
            get { return Schema.Columns[14]; }
        }
        
        
        
        public static TableSchema.TableColumn AddressColumn
        {
            get { return Schema.Columns[15]; }
        }
        
        
        
        public static TableSchema.TableColumn RemarkColumn
        {
            get { return Schema.Columns[16]; }
        }
        
        
        
        public static TableSchema.TableColumn BirthdayColumn
        {
            get { return Schema.Columns[17]; }
        }
        
        
        
        public static TableSchema.TableColumn IdentityCardColumn
        {
            get { return Schema.Columns[18]; }
        }
        
        
        
        public static TableSchema.TableColumn TakeOfficeTimeColumn
        {
            get { return Schema.Columns[19]; }
        }
        
        
        
        public static TableSchema.TableColumn LastLoginTimeColumn
        {
            get { return Schema.Columns[20]; }
        }
        
        
        
        public static TableSchema.TableColumn CreateTimeColumn
        {
            get { return Schema.Columns[21]; }
        }
        
        
        
        #endregion
		#region Columns Struct
		public struct Columns
		{
			 public static string Id = @"Id";
			 public static string Name = @"Name";
			 public static string Password = @"Password";
			 public static string Enabled = @"Enabled";
			 public static string Gender = @"Gender";
			 public static string Photo = @"Photo";
			 public static string EnglishName = @"EnglishName";
			 public static string ChineseName = @"ChineseName";
			 public static string Qq = @"QQ";
			 public static string CompanyEmail = @"CompanyEmail";
			 public static string PersonalEmail = @"PersonalEmail";
			 public static string OfficePhone = @"OfficePhone";
			 public static string OfficePhoneExt = @"OfficePhoneExt";
			 public static string HomePhone = @"HomePhone";
			 public static string CellPhone = @"CellPhone";
			 public static string Address = @"Address";
			 public static string Remark = @"Remark";
			 public static string Birthday = @"Birthday";
			 public static string IdentityCard = @"IdentityCard";
			 public static string TakeOfficeTime = @"TakeOfficeTime";
			 public static string LastLoginTime = @"LastLoginTime";
			 public static string CreateTime = @"CreateTime";
						
		}
		#endregion
		
		#region Update PK Collections
		
        #endregion
    
        #region Deep Save
		
        #endregion
	}
}
