using System; 
using System.Text; 
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration; 
using System.Xml; 
using System.Xml.Serialization;
using SubSonic; 
using SubSonic.Utilities;
// <auto-generated />
namespace AppBox
{
    /// <summary>
    /// Controller class for X_User
    /// </summary>
    [System.ComponentModel.DataObject]
    public partial class XUserController
    {
        // Preload our schema..
        XUser thisSchemaLoad = new XUser();
        private string userName = String.Empty;
        protected string UserName
        {
            get
            {
				if (userName.Length == 0) 
				{
    				if (System.Web.HttpContext.Current != null)
    				{
						userName=System.Web.HttpContext.Current.User.Identity.Name;
					}
					else
					{
						userName=System.Threading.Thread.CurrentPrincipal.Identity.Name;
					}
				}
				return userName;
            }
        }
        [DataObjectMethod(DataObjectMethodType.Select, true)]
        public XUserCollection FetchAll()
        {
            XUserCollection coll = new XUserCollection();
            Query qry = new Query(XUser.Schema);
            coll.LoadAndCloseReader(qry.ExecuteReader());
            return coll;
        }
        [DataObjectMethod(DataObjectMethodType.Select, false)]
        public XUserCollection FetchByID(object Id)
        {
            XUserCollection coll = new XUserCollection().Where("Id", Id).Load();
            return coll;
        }
		
		[DataObjectMethod(DataObjectMethodType.Select, false)]
        public XUserCollection FetchByQuery(Query qry)
        {
            XUserCollection coll = new XUserCollection();
            coll.LoadAndCloseReader(qry.ExecuteReader()); 
            return coll;
        }
        [DataObjectMethod(DataObjectMethodType.Delete, true)]
        public bool Delete(object Id)
        {
            return (XUser.Delete(Id) == 1);
        }
        [DataObjectMethod(DataObjectMethodType.Delete, false)]
        public bool Destroy(object Id)
        {
            return (XUser.Destroy(Id) == 1);
        }
        
        
    	
	    /// <summary>
	    /// Inserts a record, can be used with the Object Data Source
	    /// </summary>
        [DataObjectMethod(DataObjectMethodType.Insert, true)]
	    public void Insert(string Name,string Password,bool Enabled,string Gender,string Photo,string EnglishName,string ChineseName,string Qq,string CompanyEmail,string PersonalEmail,string OfficePhone,string OfficePhoneExt,string HomePhone,string CellPhone,string Address,string Remark,string Birthday,string IdentityCard,DateTime? TakeOfficeTime,DateTime? LastLoginTime,DateTime? CreateTime)
	    {
		    XUser item = new XUser();
		    
            item.Name = Name;
            
            item.Password = Password;
            
            item.Enabled = Enabled;
            
            item.Gender = Gender;
            
            item.Photo = Photo;
            
            item.EnglishName = EnglishName;
            
            item.ChineseName = ChineseName;
            
            item.Qq = Qq;
            
            item.CompanyEmail = CompanyEmail;
            
            item.PersonalEmail = PersonalEmail;
            
            item.OfficePhone = OfficePhone;
            
            item.OfficePhoneExt = OfficePhoneExt;
            
            item.HomePhone = HomePhone;
            
            item.CellPhone = CellPhone;
            
            item.Address = Address;
            
            item.Remark = Remark;
            
            item.Birthday = Birthday;
            
            item.IdentityCard = IdentityCard;
            
            item.TakeOfficeTime = TakeOfficeTime;
            
            item.LastLoginTime = LastLoginTime;
            
            item.CreateTime = CreateTime;
            
	    
		    item.Save(UserName);
	    }
    	
	    /// <summary>
	    /// Updates a record, can be used with the Object Data Source
	    /// </summary>
        [DataObjectMethod(DataObjectMethodType.Update, true)]
	    public void Update(int Id,string Name,string Password,bool Enabled,string Gender,string Photo,string EnglishName,string ChineseName,string Qq,string CompanyEmail,string PersonalEmail,string OfficePhone,string OfficePhoneExt,string HomePhone,string CellPhone,string Address,string Remark,string Birthday,string IdentityCard,DateTime? TakeOfficeTime,DateTime? LastLoginTime,DateTime? CreateTime)
	    {
		    XUser item = new XUser();
	        item.MarkOld();
	        item.IsLoaded = true;
		    
			item.Id = Id;
				
			item.Name = Name;
				
			item.Password = Password;
				
			item.Enabled = Enabled;
				
			item.Gender = Gender;
				
			item.Photo = Photo;
				
			item.EnglishName = EnglishName;
				
			item.ChineseName = ChineseName;
				
			item.Qq = Qq;
				
			item.CompanyEmail = CompanyEmail;
				
			item.PersonalEmail = PersonalEmail;
				
			item.OfficePhone = OfficePhone;
				
			item.OfficePhoneExt = OfficePhoneExt;
				
			item.HomePhone = HomePhone;
				
			item.CellPhone = CellPhone;
				
			item.Address = Address;
				
			item.Remark = Remark;
				
			item.Birthday = Birthday;
				
			item.IdentityCard = IdentityCard;
				
			item.TakeOfficeTime = TakeOfficeTime;
				
			item.LastLoginTime = LastLoginTime;
				
			item.CreateTime = CreateTime;
				
	        item.Save(UserName);
	    }
    }
}
