﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using SubSonic;
using FineUI;
using System.Transactions;

namespace AppBox.admin
{
    public partial class user_new : PageBase
    {
        private static readonly log4net.ILog logger = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);

        #region Module

        /// <summary>
        /// 当前页面所属的模块
        /// </summary>
        public override ModuleType Module
        {
            get
            {
                return ModuleType.CoreUser;
            }
        }

        #endregion

        #region Page_Load

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                LoadData();
            }
        }

        private void LoadData()
        {
            // 权限检查
            if (!CheckPowerNew())
            {
                CheckPowerFailWithPage();
                return;
            }

            btnClose.OnClientClick = ActiveWindow.GetHideReference();


            //// 绑定角色下拉列表
            //BindDDLRole();

            //// 绑定部门下拉列表
            //BindDDLDept();

            // 初始化用户所属角色
            InitUserRole();

            // 初始化用户所属部门
            InitUserDept();

            // 初始化用户所属职称
            InitUserJobTitle();
        }

        #region InitUserRole

        private void InitUserDept()
        {
            // 打开编辑窗口
            string selectDeptURL = String.Format("./user_select_dept.aspx?ids=<script>{0}</script>", hfSelectedDept.GetValueReference());
            tbSelectedDept.OnClientTriggerClick = Window1.GetSaveStateReference(hfSelectedDept.ClientID, tbSelectedDept.ClientID)
                    + Window1.GetShowReference(selectDeptURL, "选择用户所属的部门");

        }

        #endregion

        #region InitUserRole

        private void InitUserRole()
        {
            // 打开编辑角色的窗口
            string selectRoleURL = String.Format("./user_select_role.aspx?ids=<script>{0}</script>", hfSelectedRole.GetValueReference());
            tbSelectedRole.OnClientTriggerClick = Window1.GetSaveStateReference(hfSelectedRole.ClientID, tbSelectedRole.ClientID)
                    + Window1.GetShowReference(selectRoleURL, "选择用户所属的角色");

        }
        #endregion

        #region InitUserJobTitle

        private void InitUserJobTitle()
        {
            // 打开编辑角色的窗口
            string selectJobTitleURL = String.Format("./user_select_jobtitle.aspx?ids=<script>{0}</script>", hfSelectedJobTitle.GetValueReference());
            tbSelectedJobTitle.OnClientTriggerClick = Window1.GetSaveStateReference(hfSelectedJobTitle.ClientID, tbSelectedJobTitle.ClientID)
                    + Window1.GetShowReference(selectJobTitleURL, "选择用户拥有的职称");

        }
        #endregion

        //private void BindDDLRole()
        //{
        //    XRoleCollection items = new Select().From<XRole>()
        //        //.OrderAsc(XRole.SortIndexColumn.ColumnName)
        //        .ExecuteAsCollection<XRoleCollection>();

        //    cblRole.DataTextField = "Name";
        //    cblRole.DataValueField = "Id";
        //    cblRole.DataSource = items;
        //    cblRole.DataBind();

        //    //cblRole.Items.Insert(0, new FineUI.ListItem("--请选择--", "-1"));
        //    //cblRole.SelectedValue = "-1";
        //}

        //private void BindDDLDept()
        //{
        //    XDeptCollection items = new Select().From<XDept>()
        //        .OrderAsc(XDept.SortIndexColumn.ColumnName)
        //        .ExecuteAsCollection<XDeptCollection>();
        //    List<CustomDept> mys = CustomDeptHelper.GetMyDeptCollection(items);

        //    // 绑定到下拉列表（启用模拟树功能和不可选择项功能）
        //    ddlDept.EnableSimulateTree = true;
        //    ddlDept.DataTextField = "Name";
        //    ddlDept.DataValueField = "Id";
        //    ddlDept.DataSimulateTreeLevelField = "TreeLevel";
        //    ddlDept.DataEnableSelectField = "Enabled";
        //    ddlDept.DataSource = mys;
        //    ddlDept.DataBind();

        //    ddlDept.Items.Insert(0, new FineUI.ListItem("--请选择--", "-1"));
        //    ddlDept.SelectedValue = "-1";
        //}

        #endregion

        #region Events

        private void SaveItem()
        {
            using (TransactionScope scope = new TransactionScope())
            {
                XUser item = new XUser();
                item.Name = tbxName.Text.Trim();
                item.ChineseName = tbxRealName.Text.Trim();
                item.Gender = ddlGender.SelectedValue;
                item.CompanyEmail = tbxEmail.Text.Trim();
                item.PersonalEmail = tbxPersonalEmail.Text.Trim();
                item.OfficePhone = tbxOfficePhone.Text.Trim();
                item.OfficePhoneExt = tbxOfficePhoneExt.Text.Trim();
                item.HomePhone = tbxHomePhone.Text.Trim();
                item.CellPhone = tbxCellPhone.Text.Trim();
                item.Remark = tbxRemark.Text.Trim();
                item.Enabled = cbxEnabled.Checked;
                //item.DeptId = Convert.ToInt32(ddlDept.SelectedValue);
                item.CreateTime = DateTime.Now;
                item.Save();

                //XRoleUserCollection roleUsers = new XRoleUserCollection();
                //foreach(string roleIdStr in cblRole.SelectedValueArray)
                //{
                //    int roleId = Convert.ToInt32(roleIdStr);

                //    XRoleUser roleUser = new XRoleUser();
                //    roleUser.RoleId = roleId;
                //    roleUser.UserId = item.Id;

                //    roleUsers.Add(roleUser);
                //}
                //roleUsers.SaveAll();


                // 添加所有角色
                if (!String.IsNullOrEmpty(hfSelectedRole.Text))
                {
                    XRoleUserCollection roleUsers = new XRoleUserCollection();
                    foreach (string roleIdStr in hfSelectedRole.Text.Split(','))
                    {
                        int id = Convert.ToInt32(roleIdStr);

                        XRoleUser roleUser = new XRoleUser();
                        roleUser.RoleId = id;
                        roleUser.UserId = item.Id;

                        roleUsers.Add(roleUser);
                    }
                    roleUsers.SaveAll();
                }

                // 添加所有部门
                if (!String.IsNullOrEmpty(hfSelectedDept.Text))
                {
                    XDeptUser deptUser = new XDeptUser();
                    deptUser.DeptId = Convert.ToInt32(hfSelectedDept.Text);
                    deptUser.UserId = item.Id;
                    deptUser.Save();
                }

                // 添加所有职称
                if (!String.IsNullOrEmpty(hfSelectedJobTitle.Text))
                {
                    XJobTitleUserCollection jobtitleUsers = new XJobTitleUserCollection();
                    foreach (string idStr in hfSelectedJobTitle.Text.Split(','))
                    {
                        int id = Convert.ToInt32(idStr);

                        XJobTitleUser jobtitleUser = new XJobTitleUser();
                        jobtitleUser.JobTitleId = id;
                        jobtitleUser.UserId = item.Id;

                        jobtitleUsers.Add(jobtitleUser);
                    }
                    jobtitleUsers.SaveAll();
                }


                scope.Complete();
            }
            

        }

        protected void btnSaveClose_Click(object sender, EventArgs e)
        {
            SaveItem();

            //Alert.Show("添加成功！", String.Empty, ActiveWindow.GetHidePostBackReference());
            PageContext.RegisterStartupScript(ActiveWindow.GetHidePostBackReference());
        }
        #endregion

    }
}
