﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using SubSonic;
using FineUI;
using System.Transactions;
using System.Text;

namespace AppBox.admin
{
    public partial class user_select_dept : PageBase
    {
        private static readonly log4net.ILog logger = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);

        #region Module

        /// <summary>
        /// 当前页面所属的模块
        /// </summary>
        public override ModuleType Module
        {
            get
            {
                return ModuleType.CoreDept;
            }
        }

        #endregion

        #region Page_Load

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                LoadData();
            }
        }

        private void LoadData()
        {
            // 权限检查
            if (!CheckPowerCanRead())
            {
                CheckPowerFailWithPage();
                return;
            }

            btnClose.OnClientClick = ActiveWindow.GetHideReference();


            _deptId = GetQueryIntValue("ids");

            // 绑定列表
            BindGrid();

            // 初始化选择项
            if (_selectedRowIndex != -1)
            {
                Grid1.SelectedRowIndex = _selectedRowIndex;
            }
        }

        private int _deptId;
        private int _selectedRowIndex = -1;

        private void BindGrid()
        {
            SqlQuery q = new Select().From<XDept>();

            q.OrderAsc(XDept.SortIndexColumn.ColumnName);
            XDeptCollection depts = q.ExecuteAsCollection<XDeptCollection>();

            List<CustomDept> mys = CustomDeptHelper.GetMyDeptCollection(depts);

            Grid1.DataSource = mys;
            Grid1.DataBind();
        }

        #endregion

        #region Events

        protected void btnSaveClose_Click(object sender, EventArgs e)
        {
            int selectedRowIndex = Grid1.SelectedRowIndex;

            string deptId = Grid1.DataKeys[selectedRowIndex][0].ToString();
            string deptName = Grid1.DataKeys[selectedRowIndex][1].ToString();

            PageContext.RegisterStartupScript(ActiveWindow.GetWriteBackValueReference(deptId, deptName)
                 + ActiveWindow.GetHideReference());
        }


        protected void Grid1_RowDataBound(object sender, FineUI.GridRowEventArgs e)
        {
            // 行绑定后，确定应该选择哪一行
            CustomDept dept = e.DataItem as CustomDept;
            if (dept != null && _deptId == dept.Id)
            {
                _selectedRowIndex = e.RowIndex;
            }
        }
        
        #endregion

    }
}
