﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using SubSonic;
using FineUI;
using System.Transactions;
using System.Text;

namespace AppBox.admin
{
    public partial class user_select_jobtitle : PageBase
    {
        private static readonly log4net.ILog logger = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);

        #region Module

        /// <summary>
        /// 当前页面所属的模块
        /// </summary>
        public override ModuleType Module
        {
            get
            {
                return ModuleType.CoreJobTitle;
            }
        }

        #endregion

        #region Page_Load

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                LoadData();
            }
        }

        private void LoadData()
        {
            // 权限检查
            if (!CheckPowerCanRead())
            {
                CheckPowerFailWithPage();
                return;
            }

            btnClose.OnClientClick = ActiveWindow.GetHideReference();

            string ids = GetQueryValue("ids");
            

            // 绑定角色复选框列表
            BindDDLRole();

            // 初始化角色复选框列表的选择项
            cblJobTitle.SelectedValueArray = ids.Split(',');
        }

        private void BindDDLRole()
        {
            XJobTitleCollection items = new Select().From<XJobTitle>()
                //.OrderAsc(XJobTitle.SortIndexColumn.ColumnName)
                .ExecuteAsCollection<XJobTitleCollection>();

            cblJobTitle.DataTextField = "Name";
            cblJobTitle.DataValueField = "Id";
            cblJobTitle.DataSource = items;
            cblJobTitle.DataBind();
        }

        #endregion

        #region Events

        protected void btnSaveClose_Click(object sender, EventArgs e)
        {
            StringBuilder sbValue = new StringBuilder();
            StringBuilder sbText = new StringBuilder();
            foreach (CheckItem item in cblJobTitle.SelectedItemArray)
            {
                sbValue.AppendFormat("{0},", item.Value);
                sbText.AppendFormat("{0}，", item.Text);
            }
            string roleValues = sbValue.ToString().TrimEnd(',');
            string roleTexts = sbText.ToString().TrimEnd('，');

            PageContext.RegisterStartupScript(ActiveWindow.GetWriteBackValueReference(roleValues, roleTexts)
                + ActiveWindow.GetHideReference());
        }

        #endregion

    }
}
